diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
index d4399a950..45e01da9f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeFancyRainforest.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -412,7 +412,7 @@ public class WorldFeatureTreeFancyRainforest extends WorldFeature
             basePos[0], (basePos[1] + field_878_e) - 1, basePos[2]
         };
         int idBelow = worldObj.getBlockId(basePos[0], basePos[1] - 1, basePos[2]);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES))
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES))
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
index c19e11a01..4794f7030 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.world.generate.feature.tree;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
+import net.minecraft.core.block.BlockLogicFlower;
+import net.minecraft.core.block.BlockLogicLeavesBase;
+import net.minecraft.core.block.BlockLogicLog;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockFlower;
-import net.minecraft.core.block.BlockLog;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
@@ -24,8 +24,8 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	protected World world;
 	protected Random random;
 	
-	protected Block log;
-	protected Block leaves;
+	protected Block<?> log;
+	protected Block<?> leaves;
 	protected boolean big;
 	
 	protected boolean update;
@@ -55,7 +55,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 	protected Set<Integer> intSet = new HashSet<>();
 	protected List<Integer> intList = new ArrayList<>();
 	@MethodParametersAnnotation(names = {"log", "leaves", "big", "update"})
-	public WorldFeatureTreePalm(Block log, Block leaves, boolean big, boolean update, boolean checkForWater) {
+	public WorldFeatureTreePalm(Block<?> log, Block<?> leaves, boolean big, boolean update, boolean checkForWater) {
 		this.log = log;
 		this.leaves = leaves;
 		this.update = update;
@@ -176,20 +176,11 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		if(id == 0) {
 			return true;
 		}
-		Block block = Blocks.getBlock(id);
+		Block<?> block = Blocks.getBlock(id);
 		
 		// TODO Create BlockTag and apply to all trees
-		if(block instanceof BlockLog) {
-			return true;
-		}
-		if(block instanceof BlockLeavesBase) {
-			return true;
-		}
-		if(block instanceof BlockFlower) {
-			return true;
-		}
-		return false;
-	}
+        return Block.hasLogicClass(block, BlockLogicLog.class) || Block.hasLogicClass(block, BlockLogicLeavesBase.class) || Block.hasLogicClass(block, BlockLogicFlower.class);
+    }
 	
 	public boolean isClearRange(int x, int y, int z, int w, int h, int d) {
 		for(int i = -w; i <= w; i++) {
@@ -316,7 +307,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		int distance = 1;
 		for(int xi = x - distance; xi <= x + distance; xi++){
 			for(int zi = z - distance; zi <= z + distance; zi++){
-				Block blockAtRange = world.getBlock(xi, y-1, zi);
+				Block<?> blockAtRange = world.getBlock(xi, y-1, zi);
 				if(blockAtRange != null && blockAtRange.hasTag(BlockTags.IS_WATER)){
 					return true;
 				}
@@ -325,19 +316,19 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		return false;
 	}
 	
-	public void generateBlock(int x, int y, int z, Block block) {
+	public void generateBlock(int x, int y, int z, Block<?> block) {
 		if(update) {
-			world.setBlockWithNotify(x, y, z, block.id);
+			world.setBlockWithNotify(x, y, z, block.id());
 		}else {
-			world.setBlock(x, y, z, block.id);
+			world.setBlock(x, y, z, block.id());
 		}	
 	}
 	
 	public boolean canGrowOnThisBlock(int id, int x, int y, int z) {
-		if(Block.hasTag(id, BlockTags.GROWS_TREES)) {
+		if(Blocks.hasTag(id, BlockTags.GROWS_TREES)) {
 			return true;
 		}
-		if(id == Blocks.SAND.id) {
+		if(id == Blocks.SAND.id()) {
 			if(checkForWater && !waterNearby(x, y, z)) {
 				return false;
 			}
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
index c4c6070ff..283fd33d2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShapeSwamp.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
@@ -70,7 +69,7 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
             return false;
         }
         int sinkToFloor = 0;
-        for(; world.getBlockId(x, (y -sinkToFloor)-1, z)==Blocks.FLUID_WATER_STILL.id; sinkToFloor++) {
+        for(; world.getBlockId(x, (y -sinkToFloor)-1, z)==Blocks.FLUID_WATER_STILL.id(); sinkToFloor++) {
 
             if (sinkToFloor > 3)
                 return false;
@@ -78,12 +77,12 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
         int oldY = y;
         y = y -sinkToFloor;
         int idBelow = world.getBlockId(x, y - 1, z);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - trunkLength + sinkToFloor - 1)
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - trunkLength + sinkToFloor - 1)
         {
             return false;
         }
         WorldFeatureTree.onTreeGrown(world, x, y, z);
-        world.setBlockWithNotify(x, y - 1, z, Blocks.DIRT.id);
+        world.setBlockWithNotify(x, y - 1, z, Blocks.DIRT.id());
         for(int k1 = (y - 3) + trunkLength + sinkToFloor; k1 <= y + trunkLength + sinkToFloor; k1++)
         {
             int j2 = k1 - (y + trunkLength + sinkToFloor);
@@ -118,7 +117,7 @@ public class WorldFeatureTreeShapeSwamp extends WorldFeature
         for(int l1 = 0; l1 < trunkLength + sinkToFloor; l1++)
         {
             int k2 = world.getBlockId(x, y + l1, z);
-            if(k2 == 0 || k2 == leavesID || k2 == Blocks.FLUID_WATER_STILL.id || k2 == Blocks.FLUID_WATER_FLOWING.id)
+            if(k2 == 0 || k2 == leavesID || k2 == Blocks.FLUID_WATER_STILL.id() || k2 == Blocks.FLUID_WATER_FLOWING.id())
             {
                 world.setBlockWithNotify(x, y + l1, z, logID);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
index 106b96860..4255c2b18 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeShrub.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -60,7 +60,7 @@ public class WorldFeatureTreeShrub extends WorldFeature
             return false;
         }
         int idBelow = world.getBlockId(x, y - 1, z);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - maxHeight - 1)
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - maxHeight - 1)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
index f69bc5d11..e6064cc1e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaBushy.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -69,7 +69,7 @@ public class WorldFeatureTreeTaigaBushy extends WorldFeature
             return false;
         }
         int idBelow = world.getBlockId(x, y - 1, z);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - l - 1)
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - l - 1)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
index 74f5ecd1f..a91a9b666 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTaigaTall.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -67,7 +67,7 @@ public class WorldFeatureTreeTaigaTall extends WorldFeature
             return false;
         }
         int idBelow = world.getBlockId(x, y - 1, z);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - l - 1)
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES) || y >= world.getHeightBlocks() - l - 1)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
index 4c631f893..3e0ed8af6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreeTall.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature.tree;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
@@ -67,7 +66,7 @@ public class WorldFeatureTreeTall extends WorldFeature
             return false;
         }
         int idBelow = world.getBlockId(x, y - 1, z);
-        if(!Block.hasTag(idBelow, BlockTags.GROWS_TREES)|| y >= world.getHeightBlocks() - trunkHeight - 1)
+        if(!Blocks.hasTag(idBelow, BlockTags.GROWS_TREES)|| y >= world.getHeightBlocks() - trunkHeight - 1)
         {
             return false;
         }
@@ -133,7 +132,7 @@ public class WorldFeatureTreeTall extends WorldFeature
                     world.setBlockAndMetadataWithNotify(x + xOffset, y + yOffset, z + zOffset, logID, onXAxis? 2 : 1);
                     if(random.nextInt(10)==0){
                         if(world.getBlockId(x + xOffset, y + yOffset+1, z + zOffset)==0)
-                            world.setBlockWithNotify(x + xOffset, y + yOffset+1, z + zOffset, Blocks.MUSHROOM_BROWN.id);
+                            world.setBlockWithNotify(x + xOffset, y + yOffset+1, z + zOffset, Blocks.MUSHROOM_BROWN.id());
                     }
             }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
index 248b36af7..bc326c589 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
@@ -82,7 +81,7 @@ public abstract class WorldFeatureSpoonerTree
     private boolean canGenerateTree(World world)
     {
         int blockIdUnderneath = world.getBlockId(pos[0], pos[1] - 1, pos[2]);
-        if(!Block.hasTag(blockIdUnderneath, BlockTags.GROWS_TREES))
+        if(!Blocks.hasTag(blockIdUnderneath, BlockTags.GROWS_TREES))
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
index fb8d14baf..85c6092f5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.world.pathfinder;
 
-import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicDoor;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.collection.IntHashMap;
 import net.minecraft.core.util.helper.MathHelper;
@@ -41,8 +41,7 @@ public class PathFinder
         Node pathpoint = getNode(MathHelper.floor(entity.bb.minX), MathHelper.floor(entity.bb.minY), MathHelper.floor(entity.bb.minZ));
         Node pathpoint1 = getNode(MathHelper.floor(xt - (double)(entity.bbWidth / 2.0F)), MathHelper.floor(yt), MathHelper.floor(zt - (double)(entity.bbWidth / 2.0F)));
         Node pathpoint2 = new Node(MathHelper.floor_float(entity.bbWidth + 1.0F), MathHelper.floor_float(entity.bbHeight + 1.0F), MathHelper.floor_float(entity.bbWidth + 1.0F));
-        Path pathentity = findPath(entity, pathpoint, pathpoint1, pathpoint2, distance);
-        return pathentity;
+        return findPath(entity, pathpoint, pathpoint1, pathpoint2, distance);
     }
 
     private Path findPath(Entity entity, Node pathpoint, Node pathpoint1, Node pathpoint2, float f)
@@ -192,16 +191,16 @@ public class PathFinder
                     {
                         continue;
                     }
-                    if(Blocks.blocksList[k1] instanceof BlockDoor)
+                    if(Block.hasLogicClass(Blocks.blocksList[k1], BlockLogicDoor.class))
                     {
                         int l1 = worldSource.getBlockMetadata(x1, y1, z1);
-                        if(!BlockDoor.isOpen(l1))
+                        if(!BlockLogicDoor.isOpen(l1))
                         {
                             return 0;
                         }
                         continue;
                     }
-                    Material material = Blocks.blocksList[k1].blockMaterial;
+                    Material material = Blocks.blocksList[k1].getMaterial();
                     if(material.blocksMotion())
                     {
                         return 0;
diff --git a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
index b849176cf..a32faab15 100644
--- a/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
+++ b/game/core/src/main/java/net/minecraft/core/world/saveddata/maps/ItemMapSavedData.java
@@ -116,7 +116,7 @@ public class ItemMapSavedData extends SavedData
 
         for(MapWaypoint mapWaypoint : mapWaypoints){
             if(player.distanceToSqr(mapWaypoint.xPos, mapWaypoint.yPos, mapWaypoint.zPos) <= 256D) {
-               if(player.world.getBlockId(mapWaypoint.xPos, mapWaypoint.yPos, mapWaypoint.zPos)!= Blocks.FLAG.id)
+               if(player.world.getBlockId(mapWaypoint.xPos, mapWaypoint.yPos, mapWaypoint.zPos)!= Blocks.FLAG.id())
                 {
                     mapWaypoints.remove(mapWaypoint);
                     break;
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index 6f3add051..9190e849a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -52,8 +52,8 @@ public abstract class WorldType {
             this.maxPortalY = this.maxY;
         }
         this.oceanY = properties.oceanY;
-        this.oceanBlockId = properties.oceanBlock == null ? 0 : properties.oceanBlock.id;
-        this.fillerBlockId = properties.fillerBlock == null ? 0 : properties.fillerBlock.id;
+        this.oceanBlockId = properties.oceanBlock == null ? 0 : properties.oceanBlock.id();
+        this.fillerBlockId = properties.fillerBlock == null ? 0 : properties.fillerBlock.id();
         this.dayNightCycleTicks = properties.dayNightCycleTicks;
         this.mayRespawn = properties.mayRespawn;
     }
@@ -244,8 +244,8 @@ public abstract class WorldType {
         private int maxY = 255;
         private Integer maxPortalY = null;
         private int oceanY = 128;
-        private Block oceanBlock = null;
-        private Block fillerBlock = null;
+        private Block<?> oceanBlock = null;
+        private Block<?> fillerBlock = null;
         private int dayNightCycleTicks = Global.DAY_LENGTH_TICKS;
         private boolean mayRespawn = false;
 
@@ -318,12 +318,12 @@ public abstract class WorldType {
             return this;
         }
 
-        public Properties oceanBlock(Block oceanBlock) {
+        public Properties oceanBlock(Block<?> oceanBlock) {
             this.oceanBlock = oceanBlock;
             return this;
         }
 
-        public Properties fillerBlock(Block fillerBlock) {
+        public Properties fillerBlock(Block<?> fillerBlock) {
             this.fillerBlock = fillerBlock;
             return this;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
index d9e5b0b8c..00f21012b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
@@ -26,7 +26,7 @@ public class WorldTypeFlat
 
     @Override
     public boolean isValidSpawn(World world, int x, int y, int z) {
-        return world.getBlockId(x, y, z) == Blocks.GRASS.id;
+        return world.getBlockId(x, y, z) == Blocks.GRASS.id();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index 97e93d52a..02e75163f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -63,7 +63,7 @@ public class WorldTypeOverworld
 
     @Override
     public boolean isValidSpawn(World world, int x, int y, int z) {
-        return world.getBlockId(x, y, z) == Blocks.SAND.id;
+        return world.getBlockId(x, y, z) == Blocks.SAND.id();
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
index c269a8122..5eb54d04f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
@@ -29,7 +29,7 @@ public class WorldTypeOverworldFloating
 
     @Override
     public boolean isValidSpawn(World world, int x, int y, int z) {
-        Block block = world.getBlock(x, y, z);
+        Block<?> block = world.getBlock(x, y, z);
         return world.getHeightValue(x, z) > 0 && block != null && block.isSolidRender();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
index 99834d2de..cd0b6da88 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
@@ -21,14 +21,14 @@ public class WorldTypeOverworldIndev
 
     @Override
     public boolean isValidSpawn(World world, int x, int y, int z) {
-        return world.getBlockId(x, y, z) == Blocks.GRASS.id || world.getBlockId(x, y, z) == Blocks.SAND.id || world.getBlockId(x, y, z) == Blocks.GRASS_RETRO.id;
+        return world.getBlockId(x, y, z) == Blocks.GRASS.id() || world.getBlockId(x, y, z) == Blocks.SAND.id() || world.getBlockId(x, y, z) == Blocks.GRASS_RETRO.id();
     }
 
     @Override
     public void getInitialSpawnLocation(World world) {
-        int x = 0;
-        int y = 0;
-        int z = 0;
+        int x;
+        int y;
+        int z;
         Random random = new Random(world.getRandomSeed());
         spawnLoop:
         while (true) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldInland.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldInland.java
index 5bb0326c0..7af4c8a83 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldInland.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldInland.java
@@ -11,6 +11,6 @@ public class WorldTypeOverworldInland
 
     @Override
     public boolean isValidSpawn(World world, int x, int y, int z) {
-        return world.getBlockId(x, y, z) == Blocks.GRASS.id;
+        return world.getBlockId(x, y, z) == Blocks.GRASS.id();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
index e900858ba..47ce15638 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/Weather.java
@@ -102,7 +102,7 @@ public abstract class Weather
 
 			if (world.getBlockBiome(x, y, z).hasSurfaceSnow())
 			{
-				if (blockId == Blocks.LAYER_SNOW.id)
+				if (blockId == Blocks.LAYER_SNOW.id())
 				{
 					int meta = world.getBlockMetadata(x, y, z);
 					if (meta != 0)
@@ -114,7 +114,7 @@ public abstract class Weather
 			}
 			else
 			{
-				if (blockId == Blocks.LAYER_SNOW.id)
+				if (blockId == Blocks.LAYER_SNOW.id())
 				{
 					int meta = world.getBlockMetadata(x, y, z);
 					if (meta != 0)
@@ -127,9 +127,9 @@ public abstract class Weather
 						world.setBlockWithNotify(x, y, z, 0);
 					}
 				}
-				else if (blockIdBelow == Blocks.ICE.id)
+				else if (blockIdBelow == Blocks.ICE.id())
 				{
-					world.setBlockWithNotify(x, y - 1, z, Blocks.FLUID_WATER_STILL.id);
+					world.setBlockWithNotify(x, y - 1, z, Blocks.FLUID_WATER_STILL.id());
 				}
 			}
 		}
@@ -151,20 +151,20 @@ public abstract class Weather
 
 				if (world.getBlockBiome(chunk.xPosition * 16 + x, y, chunk.zPosition * 16 + z).hasSurfaceSnow())
 				{
-					if (blockId == Blocks.LAYER_SNOW.id)
+					if (blockId == Blocks.LAYER_SNOW.id())
 					{
 						chunk.setBlockMetadata(x, y, z, 0);
 					}
 				}
 				else
 				{
-					if (blockId == Blocks.LAYER_SNOW.id)
+					if (blockId == Blocks.LAYER_SNOW.id())
 					{
 						chunk.setBlockID(x, y, z, 0);
 					}
-					else if (blockIdBelow == Blocks.ICE.id)
+					else if (blockIdBelow == Blocks.ICE.id())
 					{
-						chunk.setBlockID(x, y - 1, z, Blocks.FLUID_WATER_STILL.id);
+						chunk.setBlockID(x, y - 1, z, Blocks.FLUID_WATER_STILL.id());
 					}
 				}
 			}
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
index 117107415..6b5597651 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherSnow.java
@@ -4,7 +4,6 @@ import java.util.Random;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockLayerSnow;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
@@ -56,14 +55,14 @@ zLoop:		for (int z = 0; z < 16; z++)
 
 				if (y >= 0 && y < world.getHeightBlocks() && chunk.getBrightness(LightLayer.Block, x, y, z) < 10)
 				{
-					if (blockId == 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, worldX, y, worldZ) && blockIdBelow != Blocks.ICE.id)
+					if (blockId == 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, worldX, y, worldZ) && blockIdBelow != Blocks.ICE.id())
 					{
-						chunk.setBlockIDWithMetadataRaw(x, y, z, Blocks.LAYER_SNOW.id, chunk.getBlockMetadata(x, y, z));
+						chunk.setBlockIDWithMetadataRaw(x, y, z, Blocks.LAYER_SNOW.id(), chunk.getBlockMetadata(x, y, z));
 					}
-					else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id && chunk.getBlockMetadata(x, y - 1, z) == 0) {
-						chunk.setBlockIDWithMetadataRaw(x, y - 1, z, Blocks.ICE.id, chunk.getBlockMetadata(x, y - 1, z));
-						if (chunk.getBlockID(x, y - 2, z) == Blocks.FLUID_WATER_STILL.id){
-							chunk.setBlockIDWithMetadataRaw(x, y - 2, z, Blocks.FLUID_WATER_FLOWING.id, chunk.getBlockMetadata(x, y - 2, z));
+					else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id() && chunk.getBlockMetadata(x, y - 1, z) == 0) {
+						chunk.setBlockIDWithMetadataRaw(x, y - 1, z, Blocks.ICE.id(), chunk.getBlockMetadata(x, y - 1, z));
+						if (chunk.getBlockID(x, y - 2, z) == Blocks.FLUID_WATER_STILL.id()){
+							chunk.setBlockIDWithMetadataRaw(x, y - 2, z, Blocks.FLUID_WATER_FLOWING.id(), chunk.getBlockMetadata(x, y - 2, z));
 						}
 					}
 				}
@@ -95,30 +94,30 @@ zLoop:		for (int z = 0; z < 16; z++)
 		
 		if (world.weatherManager.getWeatherPower() > 0.6f && y >= 0 && y < world.getHeightBlocks() && world.getSavedLightValue(LightLayer.Block, x, y, z) < 10)
 		{
-			if (blockId == 0 && blockIdBelow != 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, x, y, z) && blockIdBelow != Blocks.ICE.id)
+			if (blockId == 0 && blockIdBelow != 0 && Blocks.LAYER_SNOW.canPlaceBlockAt(world, x, y, z) && blockIdBelow != Blocks.ICE.id())
 			{
 				if(snow)
 				{
-					world.setBlockWithNotify(x, y, z, Blocks.LAYER_SNOW.id);
+					world.setBlockWithNotify(x, y, z, Blocks.LAYER_SNOW.id());
 				}
 			}
-			else if (world.weatherManager.getWeatherPower() > 0.5f && blockId == Blocks.LAYER_SNOW.id && world.getSeasonManager().getCurrentSeason() != null && (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER))
+			else if (world.weatherManager.getWeatherPower() > 0.5f && blockId == Blocks.LAYER_SNOW.id() && world.getSeasonManager().getCurrentSeason() != null && (world.getSeasonManager().getCurrentSeason().hasDeeperSnow || biome == Biomes.OVERWORLD_GLACIER))
 			{
 				if(snow) {
-					((BlockLayerSnow)Blocks.LAYER_SNOW).accumulate(world, x, y, z);
+					Blocks.LAYER_SNOW.getLogic().accumulate(world, x, y, z);
 				}
 			}
-			else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id && world.getBlockMetadata(x, y - 1, z) == 0)
+			else if (blockIdBelow == Blocks.FLUID_WATER_STILL.id() && world.getBlockMetadata(x, y - 1, z) == 0)
 			{
 				if(rand.nextFloat() < world.weatherManager.getWeatherPower() * world.weatherManager.getWeatherIntensity())
 				{
 					for(int i=0; i < 4; i++)
 					{
 						Direction direction = Direction.horizontalDirections[i];
-						Block block = world.getBlock(x + direction.getOffsetX(), y - 1, z + direction.getOffsetZ());
+						Block<?> block = world.getBlock(x + direction.getOffsetX(), y - 1, z + direction.getOffsetZ());
 						if(block == Blocks.ICE || block != null && block.isSolidRender())
 						{
-							world.setBlockWithNotify(x, y - 1, z, Blocks.ICE.id);
+							world.setBlockWithNotify(x, y - 1, z, Blocks.ICE.id());
 							break;
 						}
 					}	
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
index 4daebdace..f714ff933 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.world.weather;
 
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
@@ -70,7 +69,7 @@ public class WeatherStorm extends WeatherRain
 		weight += checkY;
 		weight += material.getConductivity();
 
-		List<Entity> entityList = world.getEntitiesWithinAABB(Mob.class, AABB.getTemporaryBB(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
+		List<Mob> entityList = world.getEntitiesWithinAABB(Mob.class, AABB.getTemporaryBB(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
 		if (!entityList.isEmpty()){
 			weight += 4; // :)
 		}
